diff -Nur ircd-hybrid-6.3.1/README.SSL ircd-hybrid-6-OpenSSL/README.SSL
--- ircd-hybrid-6.3.1/README.SSL	1970-01-01 02:00:00.000000000 +0200
+++ ircd-hybrid-6-OpenSSL/README.SSL	2002-12-13 22:56:49.000000000 +0200
@@ -0,0 +1,120 @@
+		OpenSSL support for hybrid ircd 6.x
+-------------------------------------------------------------------------
+-> TOC
+    1. Why SSL support
+    2. Installation process
+    3. F.A.Q.
+    4. Credits
+    
+    
+ 1. Why SSL support
+    
+  Secure Socket Layer (SSL) is a technology that allows clients and servers to
+communicate over a secured connection. In this secure connection, the data that
+is being sent is encrypted before being sent, then decrypted upon receipt and 
+prior to processing. Both the client and the server encrypt all traffic before
+sending any data. 
+  Another important aspect of the SSL protocol is authentication. During your
+initial attempt to communicate with a server over a secure connection, that
+server will present your irc client with a set of credentials in the form of a
+server certificate. The purpose of the certificate is to verify that the server
+is who and what it claims to be. In some cases, the server may request a 
+certificate that the client is who and what it claims to be (which is known as
+client authentication). 
+    
+ To install and configure SSL support on hybrid ircd, you need:
+ - OpenSSL libraries and includes 
+			 http://www.openssl.org/source/
+ - hybrid ircd 6.x source   
+			 http://sourceforge.net/projects/ircd-hybrid
+			 
+	
+ 2. Installation process
+
+    If you have downloaded the patch untar the hybrid ircd source and enter its
+ directory and apply the patch.
+    example: 
+	# tar xzlf ircd-hybrid-6.3.1.tgz
+	# cd ircd-hybrid-6.3.1
+	# patch -p1 < /path/to/ircd-hybrid-6-ssl.patch
+
+    In case you have downloaded the prepatched ircd hybrid prepatched source 
+ tarball, you can skip the last step in the above example. After unpacking you
+ must run configure with the --enable-openssl option in order to activate the
+ SSL support.
+    example:
+	# ./configure --enable-openssl
+ If the configure script says that the OpenSSL support is desired but can't be
+ enabled you should tell it where are the openssl headers and libraries located.
+    example:
+	# ./configure --enable-openssl	
+	creating cache ./config.cache
+	.... follows some stuff with yes and no :) ...
+	checking if OpenSSL support is desired... yes	 <-|
+	checking for openssl/ssl.h... no		   | - Check these...
+	checking if OpenSSL support can be enabled... no <-|
+	.... even more stuff with yes and no ...
+	creating ./config.status
+	creating Makefile
+	creating adns/Makefile
+	creating src/Makefile
+	creating tools/Makefile
+	creating include/setup.h
+
+    You should specify the location of the OpenSSL headers and libraries...
+	# ./configure --enable-openssl=/foo/bar
+    Replace /foo/bar with your path :)
+ 
+ If the configure script still fails to find OpenSSL try generating it again
+ with autoconf.
+    example:
+	# cd autoconf
+	# autoconf
+	# cd ../
+	# cp autoconf/configure ./
+	Rerun configure following the above insturctions
+	
+ After configuring edit include/config.h to set up the ircd and then edit 
+ include/ssl.h to set the path to your server's key and certificate.
+ Near the end of include/config.h you will notice that NOT_SSLCLIENT is 
+ undefined. If you define it your server will _NOT_ use ssl when connecting
+ to other server. I advise you not to touch this because everything goes 
+ nonsense when your server to server traffic is not encrypted :) 
+ 
+ Run 'make' and 'make install'.
+ 
+ You are ready to run :)
+ 
+ In ircd.conf along with the original P: directive you may use two new: 
+ F: and Z:
+      example:
+        P:6667 // This line tell ircd to listen on port 6667 for SSLed and 
+		  plain connections. Mixed port
+	Z:7000 // This is SSL only port. Plain connections will be dropped.
+	F:9000 // This is plain port. SSL connections will be dropped.
+	
+
+ 3. F.A.Q.
+   Q: I can't connect to any SSL port but I can connect to a mixed one.
+   A: Check if your client supports SSL connection method. Here are some SSLed
+     clients:
+    	    BitchX at http://www.bitch.org
+	    Epic ircII at http://www.epicsol.org/
+	    ircII at http://www.eterna.com.au/ircii/
+	    Irssi at http://irssi.org/
+	    mIRC script at hmm .. I don't use mIRC... try search on google ;)
+	    
+   Q: Is there any SSL support for hybserv IRC services?
+   A: Yes, there is. Check out the files at 
+      http://www.masterbo.org/filez.php?pid=5
+      
+   Q: Why should I use your patch instead of the ircd hybrid 7?
+   A: Why should I drive BMW instead of Porsche?
+   
+   Q: Where do I get a free blowjob?
+   A: Get a girlfriend ;]
+   
+ 4. Credits
+ Basic idea and testing - Georgi Ivanov /NightWish/ (nightwish@e-bulgaria.net)
+ First time coding, testing - Boyan Krastev /MasterBo/ (firebird@masterbo.org)
+ Totally recoded - Jorko /desync/ (ctapnec@freeshell.org)
\ No newline at end of file
diff -Nur ircd-hybrid-6.3.1/autoconf/configure.in ircd-hybrid-6-OpenSSL/autoconf/configure.in
--- ircd-hybrid-6.3.1/autoconf/configure.in	2002-01-28 06:36:52.000000000 +0200
+++ ircd-hybrid-6-OpenSSL/autoconf/configure.in	2002-12-13 22:29:33.000000000 +0200
@@ -10,6 +10,13 @@
 AC_SUBST(PACKAGE)
 AC_SUBST(VERSION)
 
+dnl
+dnl OpenSSL support (see README.SSL)
+dnl
+AC_ARG_WITH(ssl,
+[  --enable-openssl[=DIR] link with SSL support, see README.SSL
+  --disable-openssl	  disable SSL (default)])
+
 dnl Checks for programs.
 AC_PROG_CC
 AC_ISC_POSIX
@@ -44,6 +51,177 @@
 dnl check for poll() call
 AC_CHECK_FUNC(poll, AC_DEFINE(USE_POLL),)
 
+if test x"$enable_openssl" = x; then
+  dnl Canonicalize unspecified with-ssl setting to "auto".  This
+  dnl implements the "auto-detect by default" feature.  If you want to
+  dnl change this to "ignore SSL by default", change "auto" to "no".
+  enable_openssl=no
+fi
+
+dnl Detection of OpenSSL is much hairier than the detection of other
+dnl libraries because OpenSSL can be compiled as a third-party
+dnl library, which means it will not be found without additional
+dnl linker magic.  It would be really nice to rework this check into
+dnl an AC_DEFUN so that we can reuse it for other third-party
+dnl libraries.
+
+if test x"$enable_openssl" != x"no"; then
+
+  ircd_force_ssl=no
+  if test x"$enable_openssl" = x"yes"; then
+    ircd_force_ssl=yes
+  fi
+
+  if test x"$enable_openssl" = x"yes" || test x"$enable_openssl" = x"auto"; then
+    dnl OpenSSL's root was not specified, so we have to guess.  First
+    dnl try the system default location, then "/usr/local/ssl" (where
+    dnl OpenSSL installs by default), then "/usr/local" (traditional
+    dnl choice for installation root), then "/opt".
+    ssl_all_roots="system-default /usr/local/ssl /usr/local /opt"
+  else
+    dnl Root has been specified by the user.
+    ssl_all_roots=$enable_openssl
+    ircd_force_ssl=yes
+  fi
+
+  ircd_save_CC=$CC
+  ircd_save_LIBS=$LIBS
+  ircd_save_LDFLAGS=$LDFLAGS
+  ircd_save_CPPFLAGS=$CPPFLAGS
+
+  dnl Use libtool for OpenSSL tests so we can specify "-R<rpath>"
+  dnl without having to know how the linker handles it.
+  CC="$SHELL libtool $CC"
+
+  dnl Unfortunately, as of this writing (OpenSSL 0.9.6), the libcrypto
+  dnl shared library doesn't record its dependency on libdl, so we
+  dnl need to check for it ourselves so we won't fail to link due to a
+  dnl lack of -ldl.  Most OSes use dlopen(), but HP-UX uses
+  dnl shl_load().
+  AC_CHECK_LIB(dl,dlopen)
+  AC_CHECK_LIB(dl,shl_load)
+
+  ssl_success=no
+
+  dnl Now try to find SSL libraries in each of the likely SSL roots.
+  for ssl_root in $ssl_all_roots
+  do
+    if test x"$ssl_root" = x"system-default"; then
+      dnl Try the default include and library locations.
+      SSL_INCLUDES=
+    else
+      dnl Try this specific root.
+      SSL_INCLUDES=-I$ssl_root/include
+      dnl It's OK to use -R directly because libtool will
+      dnl interpret it for us.
+      LDFLAGS="-L$ssl_root/lib -R$ssl_root/lib $ircd_save_LDFLAGS"
+    fi
+
+    AC_MSG_RESULT([->> Looking for SSL libraries in $ssl_root])
+
+    dnl Check whether the compiler can find the include files.  On
+    dnl some systems Gcc finds libraries in /usr/local/lib, but fails
+    dnl to find the includes in /usr/local/include.
+
+    ssl_found_includes=no
+    CPPFLAGS="$SSL_INCLUDES $ircd_save_CPPFLAGS"
+
+    AC_MSG_CHECKING([for needed OpenSSL includes])
+
+    AC_TRY_CPP([#include <openssl/ssl.h>
+#include <openssl/rsa.h>
+],
+      AC_MSG_RESULT(found!); ssl_found_includes=yes,
+      AC_MSG_RESULT(not found!)
+    )
+
+    if test x"$ssl_found_includes" = xno; then
+      continue
+    fi
+
+    ssl_link_failure=no
+
+    dnl Make sure that the checks don't run afoul of the cache.  It
+    dnl would be nicer to temporarily turn off the cache, but
+    dnl apparently Autoconf doesn't allow that.
+
+    unset ac_cv_lib_crypto_RSA_new
+    unset ac_cv_lib_ssl_SSL_new
+
+    dnl These checks need to be in this order, or you'll get a link
+    dnl failure if you use a static libcrypto.a and libssl.a rather
+    dnl than shared libraries.
+
+    AC_CHECK_LIB(crypto, RSA_new, , ssl_link_failure=yes)
+    AC_CHECK_LIB(ssl, SSL_new, , ssl_link_failure=yes)
+
+    if test x"$ssl_link_failure" = xyes; then
+      dnl One or both libs failed to link.
+      continue
+    fi
+
+    dnl The libraries link.  But we still need to check if the program
+    dnl linked with those libraries under these settings with run.  On
+    dnl some systems (Solaris), Gcc adds -L/usr/local/lib to the
+    dnl linking line, but fails to add -R/usr/local/lib, thus creating
+    dnl executables that link, but fail to run.
+
+    dnl If we are cross-compiling, just assume that working linkage
+    dnl implies working executable.
+
+    ssl_run_failure=no
+
+    AC_MSG_CHECKING(whether SSL libs are resolved at runtime)
+    AC_TRY_RUN([
+int RSA_new();
+int SSL_new();
+main(){return 0;}
+],
+      AC_MSG_RESULT(yes),
+      AC_MSG_RESULT(no); ssl_run_failure=yes,
+      AC_MSG_RESULT(cross)
+    )
+
+    if test x"$ssl_run_failure" = xno; then
+      ssl_success=yes
+      break
+    fi
+  done
+
+  if test x"$ssl_success" = xyes; then
+    dnl AC_MSG_RESULT doesn't look right here, but I'm not sure what
+    dnl to use instead.
+    AC_MSG_RESULT(->> Compiling in support for SSL in $ssl_root)
+    AC_DEFINE(ALLOW_SSL)
+    AC_SUBST(SSL_INCLUDES)
+    SSL_LIBS=$LDFAGS
+    AC_SUBST(SSL_LIBS)
+  else
+    SSL_LIBS=
+    AC_SUBST(SSL_LIBS)
+    LDFLAGS=$ircd_save_LDFLAGS
+    LIBS=$ircd_save_LIBS
+
+    dnl If linking with SSL was forced rather than auto-detected, then
+    dnl bail out if SSL failed.
+    if test x"$ircd_force_ssl" = x"yes"; then
+      exec >&2
+      echo "ERROR: Failed to find OpenSSL libraries."
+      exit 2
+    fi
+  fi
+
+  dnl Restore the compiler setting.
+  CC=$ircd_save_CC
+
+  dnl Restore the CPPFLAGS.  Do this regardless of whether linking
+  dnl with SSL succeeded -- SSL includes will be handled using
+  dnl @SSL_INCLUDES@.
+  CPPFLAGS=$ircd_save_CPPFLAGS
+fi
+
+
+
 dnl taken from ircd's Config script
 AC_MSG_CHECKING(for non-blocking socket implementation)
 AC_TRY_RUN(
diff -Nur ircd-hybrid-6.3.1/include/client.h ircd-hybrid-6-OpenSSL/include/client.h
--- ircd-hybrid-6.3.1/include/client.h	2002-02-17 07:58:09.000000000 +0200
+++ ircd-hybrid-6-OpenSSL/include/client.h	2002-12-13 16:36:09.000000000 +0200
@@ -134,6 +134,10 @@
   struct Client*    servptr;    /* Points to server this Client is on */
   struct Client*    from;       /* == self, if Local Client, *NEVER* NULL! */
 
+#ifdef ALLOW_SSL
+  struct SSL_comm_t *ssl;
+#endif
+
   struct Whowas*    whowas;     /* Pointers to whowas structs */
   time_t            lasttime;   /* ...should be only LOCAL clients? --msa */
   time_t            firsttime;  /* time client was created */
diff -Nur ircd-hybrid-6.3.1/include/config.h ircd-hybrid-6-OpenSSL/include/config.h
--- ircd-hybrid-6.3.1/include/config.h	2002-02-17 07:58:09.000000000 +0200
+++ ircd-hybrid-6-OpenSSL/include/config.h	2002-12-13 20:29:30.000000000 +0200
@@ -100,8 +100,8 @@
  *
  */
 
-#define DPATH   "/usr/local/ircd/"
-#define SPATH   "/usr/local/ircd/ircd"
+#define DPATH   "/usr/local/sircd/"
+#define SPATH   "/usr/local/sircd/ircd"
 #define CPATH   "ircd.conf"
 #define KPATH   "kline.conf"
 #define DLPATH  "kline.conf"
@@ -148,12 +148,12 @@
 /* NETWORK_NAME
  * Displayed in place of the servername when SERVERHIDE is enabled
  */
-#define NETWORK_NAME "EFnet"
+#define NETWORK_NAME "Alliance-IRC"
 
 /* NETWORK_DESC
  * Displayed in place of the server info when SERVERHIDE is enabled
  */
-#define NETWORK_DESC "Eris Free Network"
+#define NETWORK_DESC "Alliance IRC NetWork"
 
 
 /* TS_MAX_DELTA and TS_WARN_DELTA -  allowed delta for TS when another
@@ -208,8 +208,8 @@
  *
  * These need to be defined if you want to use SYSLOG logging, too.
  */
-#define FNAME_USERLOG "/usr/local/ircd/users"
-#define FNAME_OPERLOG "/usr/local/ircd/opers"
+#define FNAME_USERLOG "/usr/local/sircd/users"
+#define FNAME_OPERLOG "/usr/local/sircd/opers"
 
 /* RFC1035_ANAL
  * Defining this causes ircd to reject hostnames with non-compliant chars.
@@ -344,6 +344,7 @@
  * HIDE_SPOOF_IPS.
  */
 #define SPOOF_NOTICE
+#define SPOOF_FREEDOM
 
 /* STATS_NOTICE - See a notice when a user does a /stats
  *
@@ -458,7 +459,7 @@
  * to a leaf which just has 1 server (typically the uplink). Define this
  * correctly for performance reasons.
  */
-#undef  HUB
+#define  HUB
 
 /* CMDLINE_CONFIG - allow conf-file to be specified on command line
  * NOTE: defining CMDLINE_CONFIG and installing ircd SUID or SGID is a MAJOR
@@ -1024,4 +1025,7 @@
 
 #define CONFIG_H_LEVEL_6_3
 
+/* Define this in case of SSL support and if u don't want your server to act as SSL client */
+#undef NOT_SSLCLIENT
+
 #endif /* INCLUDED_config_h */
diff -Nur ircd-hybrid-6.3.1/include/ircd_defs.h ircd-hybrid-6-OpenSSL/include/ircd_defs.h
--- ircd-hybrid-6.3.1/include/ircd_defs.h	2002-02-17 07:58:09.000000000 +0200
+++ ircd-hybrid-6-OpenSSL/include/ircd_defs.h	2002-12-13 20:30:07.000000000 +0200
@@ -35,7 +35,7 @@
 #define HOSTLEN         63      /* Length of hostname.  Updated to         */
                                 /* comply with RFC1123                     */
 
-#define NICKLEN         9       /* Necessary to put 9 here instead of 10
+#define NICKLEN         12       /* Necessary to put 9 here instead of 10
                                  * if s_msg.c/m_nick has been corrected.
                                  * This preserves compatibility with old
                                  * servers --msa
diff -Nur ircd-hybrid-6.3.1/include/listener.h ircd-hybrid-6-OpenSSL/include/listener.h
--- ircd-hybrid-6.3.1/include/listener.h	2001-07-18 04:37:05.000000000 +0300
+++ ircd-hybrid-6-OpenSSL/include/listener.h	2002-12-13 16:36:09.000000000 +0200
@@ -32,6 +32,10 @@
 #include "ircd_defs.h"       /* HOSTLEN */
 #endif
 
+#ifdef ALLOW_SSL
+#include "ssl.h"
+#endif
+
 struct Client;
 
 struct Listener {
@@ -39,6 +43,9 @@
   const char*      name;               /* listener name */
   int              fd;                 /* file descriptor */
   int              port;               /* listener IP port */
+#ifdef ALLOW_SSL
+  u8               port_type;          /* listener IP port type - maybe Plain/SSL/Mixed */
+#endif
   int              ref_count;          /* number of connection references */
   int              active;             /* current state of listener */
   int              index;              /* index into poll array */
@@ -50,7 +57,11 @@
 extern struct Listener* ListenerPollList; /* GLOBAL - listener list */
 
 extern void        accept_connection(struct Listener* listener);
+#ifdef ALLOW_SSL
+extern void        add_listener(int port, const char* vaddr_ip, u8 port_type);
+#else
 extern void        add_listener(int port, const char* vaddr_ip);
+#endif
 extern void        close_listener(struct Listener* listener);
 extern void        close_listeners(void);
 extern void        free_listener(struct Listener* listener);
diff -Nur ircd-hybrid-6.3.1/include/patchlevel.h ircd-hybrid-6-OpenSSL/include/patchlevel.h
--- ircd-hybrid-6.3.1/include/patchlevel.h	2002-04-18 05:54:49.000000000 +0300
+++ ircd-hybrid-6-OpenSSL/include/patchlevel.h	2002-12-13 20:30:32.000000000 +0200
@@ -19,5 +19,5 @@
  */
 
 #ifndef PATCHLEVEL
-#define PATCHLEVEL    "2.8/hybrid-6.3.1"
+#define PATCHLEVEL    "2.8/hybrid-6-OpenSSL"
 #endif
diff -Nur ircd-hybrid-6.3.1/include/s_conf.h ircd-hybrid-6-OpenSSL/include/s_conf.h
--- ircd-hybrid-6.3.1/include/s_conf.h	2001-12-15 04:42:01.000000000 +0200
+++ ircd-hybrid-6-OpenSSL/include/s_conf.h	2002-12-13 20:12:42.000000000 +0200
@@ -60,6 +60,7 @@
   time_t           hold;     /* Hold action until this time (calendar time) */
   struct Class*    c_class;     /* Class of connection */
   int              dns_pending; /* 1 if dns query pending, 0 otherwise */
+  unsigned int     cnftype;
   struct DNSQuery* dns_query;
 };
 
diff -Nur ircd-hybrid-6.3.1/include/s_serv.h ircd-hybrid-6-OpenSSL/include/s_serv.h
--- ircd-hybrid-6.3.1/include/s_serv.h	2001-12-09 21:02:09.000000000 +0200
+++ ircd-hybrid-6-OpenSSL/include/s_serv.h	2002-12-13 16:38:00.000000000 +0200
@@ -45,6 +45,7 @@
 #define CAP_EX          0x00000008      /* Can do channel +e exemptions */
 #define CAP_CHW         0x00000010      /* Can do channel wall @# */
 #define CAP_KNOCK	0x00000020
+#define CAP_SSL		0x00000040      /* SSL support */
 
 #define DoesCAP(x)      ((x)->caps)
 
diff -Nur ircd-hybrid-6.3.1/include/setup.h.in ircd-hybrid-6-OpenSSL/include/setup.h.in
--- ircd-hybrid-6.3.1/include/setup.h.in	2002-01-28 06:36:54.000000000 +0200
+++ ircd-hybrid-6-OpenSSL/include/setup.h.in	2002-12-13 16:39:09.000000000 +0200
@@ -77,3 +77,6 @@
 
 /* Define if you have the z library (-lz).  */
 #undef HAVE_LIBZ
+
+/* Define if your system have got OpenSSL support */
+#undef ALLOW_SSL
diff -Nur ircd-hybrid-6.3.1/include/ssl.h ircd-hybrid-6-OpenSSL/include/ssl.h
--- ircd-hybrid-6.3.1/include/ssl.h	1970-01-01 02:00:00.000000000 +0200
+++ ircd-hybrid-6-OpenSSL/include/ssl.h	2002-12-13 16:36:09.000000000 +0200
@@ -0,0 +1,81 @@
+#ifndef __HAVE_SSL_H
+#define __HAVE_SSL_H
+
+#include <stdlib.h>
+
+#define u8	u_int8_t
+#define u16	u_int16_t
+#define u32	u_int32_t
+
+#ifndef HOME
+#define HOME	"./"
+#endif
+#define CERTF	HOME "server-cert.pem"
+#define KEYF	HOME "server-key.pem"
+
+#include <openssl/rsa.h>
+#include <openssl/crypto.h>
+#include <openssl/x509.h>
+#include <openssl/pem.h>
+#include <openssl/ssl.h>
+#include <openssl/err.h>
+
+#define SSL_EXPECTED		0x80
+#define SSL_USESSL		0x40
+#define SSL_CONNECTED		0x20
+#define SSL_SOCKDOWN		0x10
+#define SSL_PACKETLOST		0x08
+
+#define SSLIsExpected(x)	(((x)->status) & SSL_EXPECTED)
+#define SSLIsUsed(x)		(((x)->status) & SSL_USESSL)
+#define SSLIsConn(x)		(((x)->status) & SSL_CONNECTED)
+#define SSLSetExpected(x)	((x)->status) |= SSL_EXPECTED
+#define SSLSetUsed(x)		((x)->status) |= SSL_USESSL
+#define SSLSetConn(x)		((x)->status) |= SSL_CONNECTED
+#define SSLSetAll(x)		((x)->status) |= SSL_EXPECTED|SSL_USESSL|SSL_CONNECTED
+#define SSLUnsetExpected(x)	((x)->status) &= ~SSL_EXPECTED
+#define SSLUnsetUsed(x)		((x)->status) &= ~SSL_USESSL
+#define SSLUnsetConn(x)		((x)->status) &= ~SSL_CONNECTED
+#define SSLUnsetAll(x)		((x)->status) &= ~(SSL_EXPECTED|SSL_USESSL|SSL_CONNECTED|SSL_SOCKDOWN|SSL_PACKETLOST)
+
+#define SSLSetDown(x)		((x)->status) |= SSL_SOCKDOWN
+#define SSLMustDown(x)		(((x)->status) & SSL_SOCKDOWN)
+
+#define SSLIsPackLost(x)	(((x)->status) & SSL_PACKETLOST)
+#define SSLSetPackLost(x)	((x)->status) |= SSL_PACKETLOST
+#define SSLUnsetPackLost(x)	((x)->status) &= ~SSL_PACKETLOST
+
+#define CHK_NULL(x)		((x) == NULL)
+#define CHK_ERR(x) { \
+		char errbuff[256]; \
+		unsigned long sslerr = ERR_get_error (); \
+		if (sslerr) { \
+			ERR_error_string (sslerr, errbuff); \
+			log ((x), "SSL error >>> %s", errbuff); \
+		} \
+}
+
+#define PORT_PLAIN	0x80
+#define PORT_SSL	0x40
+#define PORT_MIXED	(PORT_PLAIN|PORT_SSL)
+
+#define PORTIsPlain(x)	(((x)->port_type) & PORT_PLAIN)
+#define PORTIsSSL(x)	(((x)->port_type) & PORT_SSL)
+#define PORTIsMixed(x)	(((x)->port_type) & PORT_MIXED)
+#define PORTPlain(x)	!(((x)->port_type) ^ PORT_PLAIN)
+#define PORTSSL(x)	!(((x)->port_type) ^ PORT_SSL)
+#define PORTMixed(x)	!(((x)->port_type) ^ PORT_MIXED)
+
+
+struct SSL_comm_t {
+	u8		status;
+	SSL_CTX		*ctx;
+	SSL		*ssl;
+	X509		*cert;
+	SSL_METHOD	*meth;
+};
+
+extern struct SSL_comm_t SSL_serv;
+extern void SSL_release_all (struct SSL_comm_t *ssl);
+
+#endif
diff -Nur ircd-hybrid-6.3.1/src/client.c ircd-hybrid-6-OpenSSL/src/client.c
--- ircd-hybrid-6.3.1/src/client.c	2002-02-17 07:58:13.000000000 +0200
+++ ircd-hybrid-6-OpenSSL/src/client.c	2002-12-13 16:36:09.000000000 +0200
@@ -55,6 +55,9 @@
 #include <unistd.h>
 #include <sys/stat.h>
 
+#ifdef ALLOW_SSL
+#include "ssl.h"
+#endif
 
 /* 
  * Number of struct Client structures to preallocate at a time
@@ -184,6 +187,18 @@
 #endif
 #endif /* NULL_POINTER_NOT_ZERO */
 
+#ifdef ALLOW_SSL
+	if ((cptr->ssl = (struct SSL_comm_t *) malloc (sizeof (*cptr->ssl))) == NULL)
+	{
+		log (L_DEBUG, "not enough memory to allocate SSL comm struct");
+		goto finish;
+	}
+	memset (cptr->ssl, 0, sizeof (*cptr->ssl));
+	SSLSetExpected (cptr->ssl);
+	log (L_DEBUG, "Allocating memory for SSLconnection structure");
+finish:
+#endif
+
   return cptr;
 }
 
@@ -195,6 +210,18 @@
   assert(0 == cptr->prev);
   assert(0 == cptr->next);
 
+#ifdef ALLOW_SSL
+	if (cptr->ssl)
+	{
+		SSL_release_all (cptr->ssl);
+		SSLUnsetAll (cptr->ssl);
+		log (L_DEBUG, "Freeing SSL comm struct...");
+		free (cptr->ssl);
+		cptr->ssl = NULL;
+		log (L_DEBUG, "SSL comm struct successfuly freed");
+	}
+#endif
+
   if (cptr->local_flag) {
     if (-1 < cptr->fd)
       close(cptr->fd);
@@ -1599,7 +1626,6 @@
           ** It also makes sptr->from == NULL, thus it's unnecessary
           ** to test whether "sptr != acptr" in the following loops.
           */
-
           close_connection(sptr);
     }
 
@@ -1663,6 +1689,15 @@
         }
 
   exit_one_client(cptr, sptr, from, comment);
+#ifdef ALLOW_SSL
+	if (sptr->ssl)
+	{
+		log (L_DEBUG, "Freeing SSL comm struct...");
+		free (sptr->ssl);
+		sptr->ssl = NULL;
+		log (L_DEBUG, "SSL comm struct freed successfuly");
+	}
+#endif
   return cptr == sptr ? CLIENT_EXITED : 0;
 }
 
diff -Nur ircd-hybrid-6.3.1/src/listener.c ircd-hybrid-6-OpenSSL/src/listener.c
--- ircd-hybrid-6.3.1/src/listener.c	2001-12-12 02:29:13.000000000 +0200
+++ ircd-hybrid-6-OpenSSL/src/listener.c	2002-12-13 16:36:09.000000000 +0200
@@ -215,7 +215,11 @@
  * vhost_ip - if non-null must contain a valid IP address string in
  * the format "255.255.255.255"
  */
+#ifdef ALLOW_SSL
+void add_listener(int port, const char* vhost_ip, u8 port_type)
+#else
 void add_listener(int port, const char* vhost_ip) 
+#endif
 {
   struct Listener* listener;
   struct in_addr   vaddr;
@@ -243,6 +247,9 @@
 
   if (inetport(listener)) {
     listener->active = 1;
+#ifdef ALLOW_SSL
+	listener->port_type = port_type;
+#endif
     listener->next   = ListenerPollList;
     ListenerPollList = listener; 
   }
diff -Nur ircd-hybrid-6.3.1/src/m_capab.c ircd-hybrid-6-OpenSSL/src/m_capab.c
--- ircd-hybrid-6.3.1/src/m_capab.c	2001-07-18 04:37:12.000000000 +0300
+++ ircd-hybrid-6-OpenSSL/src/m_capab.c	2002-12-13 16:36:09.000000000 +0200
@@ -31,6 +31,10 @@
 #include <string.h>
 #include <assert.h>
 
+#ifdef ALLOW_SSL
+#include "ssl.h"
+#endif
+
 /*
  * m_functions execute protocol messages on this server:
  *
@@ -107,6 +111,11 @@
   else
     cptr->caps |= CAP_CAP;
 
+#ifdef ALLOW_SSL
+	if (cptr->ssl && SSLIsConn (cptr->ssl))
+		SetCapable (cptr, CAP_SSL);
+#endif
+
   for (s = strtoken(&p, parv[1], " "); s; s = strtoken(&p, NULL, " "))
   {
     for (cap = captab; cap->name; cap++)
diff -Nur ircd-hybrid-6.3.1/src/m_whois.c ircd-hybrid-6-OpenSSL/src/m_whois.c
--- ircd-hybrid-6.3.1/src/m_whois.c	2001-06-06 09:56:34.000000000 +0300
+++ ircd-hybrid-6-OpenSSL/src/m_whois.c	2002-12-13 16:43:41.000000000 +0200
@@ -37,6 +37,10 @@
 
 #include <string.h>
 
+#ifdef ALLOW_SSL
+#include "ssl.h"
+#endif
+
 static char buf[BUFSIZE];
 
 /*
@@ -276,6 +280,12 @@
                      me.name, parv[0], name, user->server,
                      a2cptr?a2cptr->info:"*Not On This Net*");
 
+#ifdef ALLOW_SSL
+ 	  if (SSLIsUsed (acptr->ssl) && SSLIsConn (acptr->ssl))
+ 		sendto_one(sptr, ":%s 293 %s %s :Uses secured connection",
+ 		     me.name, parv[0], name);
+#endif
+
           if (user->away)
             sendto_one(sptr, form_str(RPL_AWAY), me.name,
                        parv[0], name, user->away);
@@ -408,6 +418,12 @@
             sendto_one(sptr, form_str(RPL_WHOISCHANNELS),
                        me.name, parv[0], name, buf);
          
+#ifdef ALLOW_SSL
+  	  if (SSLIsUsed (acptr->ssl) && SSLIsConn (acptr->ssl))
+ 	    sendto_one(sptr, ":%s 293 %s %s :Uses secured connection",
+ 		       me.name, parv[0], name);
+#endif
+
 #ifdef SERVERHIDE
           if (!(IsAnOper(sptr) || acptr == sptr))
             sendto_one(sptr, form_str(RPL_WHOISSERVER),
diff -Nur ircd-hybrid-6.3.1/src/s_auth.c ircd-hybrid-6-OpenSSL/src/s_auth.c
--- ircd-hybrid-6.3.1/src/s_auth.c	2001-12-04 09:44:37.000000000 +0200
+++ ircd-hybrid-6-OpenSSL/src/s_auth.c	2002-12-13 16:36:09.000000000 +0200
@@ -53,6 +53,10 @@
 #include <sys/file.h>
 #include <sys/ioctl.h>
 
+#ifdef ALLOW_SSL
+#include "ssl.h"
+#endif
+
 /*
  * a bit different approach
  * this replaces the original sendheader macros
@@ -86,8 +90,16 @@
   REPORT_HOST_TOOLONG
 } ReportType;
 
+#ifndef ALLOW_SSL
 #define sendheader(c, r) \
    send((c)->fd, HeaderMessages[(r)].message, HeaderMessages[(r)].length, 0)
+#else
+#define sendheader(c, r) \
+		if (((c)->ssl) && SSLIsConn (((c)->ssl))) \
+			SSL_write((SSL *) (((c)->ssl)->ssl), HeaderMessages[(r)].message, HeaderMessages[(r)].length); \
+		else \
+			send((c)->fd, HeaderMessages[(r)].message, HeaderMessages[(r)].length, 0);
+#endif
 
 struct AuthRequest* AuthPollList = 0; /* GLOBAL - auth queries pending io */
 
